--[[
	Rockland TV - App
	Vers.: 0.1 (Stand: 11.05.2018) by bazi98

	License: GPL

	This program is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public
	License as published by the Free Software Foundation; either
	version 2 of the License, or (at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
	General Public License for more details.

	You should have received a copy of the GNU General Public
	License along with this program; if not, write to the
	Free Software Foundation, Inc., 51 Franklin St, Fifth Floor,
	Boston, MA  02110-1301, USA.

        Copyright (C) for the linked videos and for the Logo by Rockland TV (http://www.rockland.de/tv.html)or the respective owners!
]]
--[[
<webtv title="Rockland TV" url="https://livestream.com/accounts/22300522/events/6680139/player?enableInfoAndActivity=false" description="Livestream" script="rockland_tv.lua" />
]]

json = require "json"

if #arg < 1 then return nil end
local _url = arg[1]
local ret = {}
local Curl = nil

function getdata(Url)
	if Url == nil then return nil end
	if Curl == nil then
		Curl = curl.new()
	end
	local ret, data = Curl:download{ url=Url, ipv4=true, A="Mozilla/5.0 (Linux; Android 5.1.1; Nexus 4 Build/LMY48M)"}
	if ret == CURL.OK then
		return data
	else
		return nil
	end
end

function getVideoData(url)
	local feed_data = getdata(url) -- https://livestream.com/accounts/22300522/events/6680139/player?enableInfoAndActivity=false
	if feed_data then
		local m3u_url = feed_data:match('m3u8_url":"(.-)",')
		local url=nil
		local count = 0
		if m3u_url then
			local videodata = getdata(m3u_url)
			local url = ""
			local band = ""
			local resol = {[2128000]="1280x720",[678000]="640x360",[428000]="432x240"}
			for band, url in videodata:gmatch('#EXT%-X%-STREAM%-INF.-BANDWIDTH=(%d+).-(https.-)\n') do
				if url ~= nil then
					local bnum = tonumber(band)
					entry = {}
					entry['url']  = url
					entry['band'] = band
					entry['res1'] = resol[bnum]:match('(%d+)x')
					entry['res2'] = resol[bnum]:match('x(%d+)')
					entry['name'] = ""
					count = count + 1
					ret[count] = {}
					ret[count] = entry
				end
			end
		end
		return count
	end
	return 0
end

if (getVideoData(_url) > 0) then
	return json:encode(ret)
end

return ""
